/* filter.c generated by valac 0.44.6, the Vala compiler
 * generated from filter.vala, do not modify */

/*
 Copyright (C) 2009-2012 Christian Dywan <christian@twotoasts.de>
 Copyright (C) 2009-2012 Alexander Butenko <a.butenka@gmail.com>

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 See the file COPYING for the full license text.
*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#define ADBLOCK_TYPE_FEATURE (adblock_feature_get_type ())
#define ADBLOCK_FEATURE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ADBLOCK_TYPE_FEATURE, AdblockFeature))
#define ADBLOCK_FEATURE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ADBLOCK_TYPE_FEATURE, AdblockFeatureClass))
#define ADBLOCK_IS_FEATURE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ADBLOCK_TYPE_FEATURE))
#define ADBLOCK_IS_FEATURE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ADBLOCK_TYPE_FEATURE))
#define ADBLOCK_FEATURE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ADBLOCK_TYPE_FEATURE, AdblockFeatureClass))

typedef struct _AdblockFeature AdblockFeature;
typedef struct _AdblockFeatureClass AdblockFeatureClass;
typedef struct _AdblockFeaturePrivate AdblockFeaturePrivate;
typedef enum  {
	ADBLOCK_DIRECTIVE_ALLOW,
	ADBLOCK_DIRECTIVE_BLOCK
} AdblockDirective;

#define ADBLOCK_TYPE_DIRECTIVE (adblock_directive_get_type ())

#define ADBLOCK_TYPE_FILTER (adblock_filter_get_type ())
#define ADBLOCK_FILTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ADBLOCK_TYPE_FILTER, AdblockFilter))
#define ADBLOCK_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ADBLOCK_TYPE_FILTER, AdblockFilterClass))
#define ADBLOCK_IS_FILTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ADBLOCK_TYPE_FILTER))
#define ADBLOCK_IS_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ADBLOCK_TYPE_FILTER))
#define ADBLOCK_FILTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ADBLOCK_TYPE_FILTER, AdblockFilterClass))

typedef struct _AdblockFilter AdblockFilter;
typedef struct _AdblockFilterClass AdblockFilterClass;
typedef struct _AdblockFilterPrivate AdblockFilterPrivate;

#define ADBLOCK_TYPE_OPTIONS (adblock_options_get_type ())
#define ADBLOCK_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ADBLOCK_TYPE_OPTIONS, AdblockOptions))
#define ADBLOCK_OPTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ADBLOCK_TYPE_OPTIONS, AdblockOptionsClass))
#define ADBLOCK_IS_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ADBLOCK_TYPE_OPTIONS))
#define ADBLOCK_IS_OPTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ADBLOCK_TYPE_OPTIONS))
#define ADBLOCK_OPTIONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ADBLOCK_TYPE_OPTIONS, AdblockOptionsClass))

typedef struct _AdblockOptions AdblockOptions;
typedef struct _AdblockOptionsClass AdblockOptionsClass;
enum  {
	ADBLOCK_FILTER_0_PROPERTY,
	ADBLOCK_FILTER_NUM_PROPERTIES
};
static GParamSpec* adblock_filter_properties[ADBLOCK_FILTER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _AdblockFeature {
	GObject parent_instance;
	AdblockFeaturePrivate * priv;
};

struct _AdblockFeatureClass {
	GObjectClass parent_class;
	AdblockDirective* (*match) (AdblockFeature* self, const gchar* request_uri, const gchar* page_uri, GError** error);
};

struct _AdblockFilter {
	AdblockFeature parent_instance;
	AdblockFilterPrivate * priv;
	GHashTable* rules;
};

struct _AdblockFilterClass {
	AdblockFeatureClass parent_class;
	void (*insert) (AdblockFilter* self, const gchar* sig, GRegex* regex);
	GRegex* (*lookup) (AdblockFilter* self, const gchar* sig);
	guint (*size) (AdblockFilter* self);
};

struct _AdblockFilterPrivate {
	AdblockOptions* optslist;
};

static gint AdblockFilter_private_offset;
static gpointer adblock_filter_parent_class = NULL;
static GType adblock_filter_type_id = 0;

GType adblock_feature_register_type (GTypeModule * module);
GType adblock_feature_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AdblockFeature, g_object_unref)
GType adblock_directive_get_type (void) G_GNUC_CONST;
GType adblock_filter_register_type (GTypeModule * module);
GType adblock_filter_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AdblockFilter, g_object_unref)
GType adblock_options_register_type (GTypeModule * module);
GType adblock_options_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AdblockOptions, g_object_unref)
void adblock_filter_insert (AdblockFilter* self,
                            const gchar* sig,
                            GRegex* regex);
static void adblock_filter_real_insert (AdblockFilter* self,
                                 const gchar* sig,
                                 GRegex* regex);
GRegex* adblock_filter_lookup (AdblockFilter* self,
                               const gchar* sig);
static GRegex* adblock_filter_real_lookup (AdblockFilter* self,
                                    const gchar* sig);
guint adblock_filter_size (AdblockFilter* self);
static guint adblock_filter_real_size (AdblockFilter* self);
AdblockFilter* adblock_filter_construct (GType object_type,
                                         AdblockOptions* options);
AdblockFeature* adblock_feature_construct (GType object_type);
static void _g_free0_ (gpointer var);
static void _g_regex_unref0_ (gpointer var);
gboolean adblock_filter_check_rule (AdblockFilter* self,
                                    GRegex* regex,
                                    const gchar* pattern,
                                    const gchar* request_uri,
                                    const gchar* page_uri,
                                    GError** error);
gchar* adblock_options_lookup (AdblockOptions* self,
                               const gchar* sig);
static void adblock_filter_finalize (GObject * obj);

static inline gpointer
adblock_filter_get_instance_private (AdblockFilter* self)
{
	return G_STRUCT_MEMBER_P (self, AdblockFilter_private_offset);
}

static gpointer
_g_regex_ref0 (gpointer self)
{
#line 19 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	return self ? g_regex_ref (self) : NULL;
#line 147 "filter.c"
}

static void
adblock_filter_real_insert (AdblockFilter* self,
                            const gchar* sig,
                            GRegex* regex)
{
	GHashTable* _tmp0_;
	gchar* _tmp1_;
	GRegex* _tmp2_;
#line 19 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	_tmp0_ = self->rules;
#line 19 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	_tmp1_ = g_strdup (sig);
#line 19 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	_tmp2_ = _g_regex_ref0 (regex);
#line 19 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	g_hash_table_insert (_tmp0_, _tmp1_, _tmp2_);
#line 166 "filter.c"
}

void
adblock_filter_insert (AdblockFilter* self,
                       const gchar* sig,
                       GRegex* regex)
{
#line 18 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	ADBLOCK_FILTER_GET_CLASS (self)->insert (self, sig, regex);
#line 176 "filter.c"
}

static GRegex*
adblock_filter_real_lookup (AdblockFilter* self,
                            const gchar* sig)
{
	GRegex* result = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	GRegex* _tmp2_;
#line 23 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	_tmp0_ = self->rules;
#line 23 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, sig);
#line 23 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	_tmp2_ = _g_regex_ref0 ((GRegex*) _tmp1_);
#line 23 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	result = _tmp2_;
#line 23 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	return result;
#line 197 "filter.c"
}

GRegex*
adblock_filter_lookup (AdblockFilter* self,
                       const gchar* sig)
{
#line 22 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	return ADBLOCK_FILTER_GET_CLASS (self)->lookup (self, sig);
#line 206 "filter.c"
}

static guint
adblock_filter_real_size (AdblockFilter* self)
{
	guint result = 0U;
	GHashTable* _tmp0_;
#line 27 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	_tmp0_ = self->rules;
#line 27 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	result = g_hash_table_size (_tmp0_);
#line 27 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	return result;
#line 220 "filter.c"
}

guint
adblock_filter_size (AdblockFilter* self)
{
#line 26 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	return ADBLOCK_FILTER_GET_CLASS (self)->size (self);
#line 228 "filter.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 31 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	return self ? g_object_ref (self) : NULL;
#line 236 "filter.c"
}

static void
_g_free0_ (gpointer var)
{
#line 32 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	var = (g_free (var), NULL);
#line 244 "filter.c"
}

static void
_g_regex_unref0_ (gpointer var)
{
#line 32 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	(var == NULL) ? NULL : (var = (g_regex_unref (var), NULL));
#line 252 "filter.c"
}

AdblockFilter*
adblock_filter_construct (GType object_type,
                          AdblockOptions* options)
{
	AdblockFilter * self = NULL;
	AdblockOptions* _tmp0_;
	GHashFunc _tmp1_;
	GEqualFunc _tmp2_;
	GHashTable* _tmp3_;
#line 30 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	self = (AdblockFilter*) adblock_feature_construct (object_type);
#line 31 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	_tmp0_ = _g_object_ref0 (options);
#line 31 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	_g_object_unref0 (self->priv->optslist);
#line 31 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	self->priv->optslist = _tmp0_;
#line 32 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	_tmp1_ = g_str_hash;
#line 32 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	_tmp2_ = g_str_equal;
#line 32 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	_tmp3_ = g_hash_table_new_full (_tmp1_, _tmp2_, _g_free0_, _g_regex_unref0_);
#line 32 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	_g_hash_table_unref0 (self->rules);
#line 32 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	self->rules = _tmp3_;
#line 30 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	return self;
#line 284 "filter.c"
}

gboolean
adblock_filter_check_rule (AdblockFilter* self,
                           GRegex* regex,
                           const gchar* pattern,
                           const gchar* request_uri,
                           const gchar* page_uri,
                           GError** error)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gchar* opts = NULL;
	AdblockOptions* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp5_;
	const gchar* _tmp10_;
	GError* _inner_error0_ = NULL;
#line 36 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	_tmp0_ = g_regex_match_full (regex, request_uri, (gssize) -1, 0, 0, NULL, &_inner_error0_);
#line 36 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 308 "filter.c"
		gboolean _tmp1_ = FALSE;
#line 36 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
		g_propagate_error (error, _inner_error0_);
#line 36 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
		return _tmp1_;
#line 314 "filter.c"
	}
#line 36 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	if (!_tmp0_) {
#line 37 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
		result = FALSE;
#line 37 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
		return result;
#line 322 "filter.c"
	}
#line 39 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	_tmp2_ = self->priv->optslist;
#line 39 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	_tmp3_ = adblock_options_lookup (_tmp2_, pattern);
#line 39 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	opts = _tmp3_;
#line 40 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	_tmp5_ = opts;
#line 40 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	if (_tmp5_ != NULL) {
#line 334 "filter.c"
		const gchar* _tmp6_;
#line 40 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
		_tmp6_ = opts;
#line 40 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
		_tmp4_ = g_regex_match_simple (",third-party", _tmp6_, G_REGEX_CASELESS, G_REGEX_MATCH_NOTEMPTY);
#line 340 "filter.c"
	} else {
#line 40 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
		_tmp4_ = FALSE;
#line 344 "filter.c"
	}
#line 40 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	if (_tmp4_) {
#line 348 "filter.c"
		gboolean _tmp7_ = FALSE;
#line 42 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
		if (page_uri != NULL) {
#line 352 "filter.c"
			gboolean _tmp8_ = FALSE;
#line 42 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
			_tmp8_ = g_regex_match_full (regex, page_uri, (gssize) -1, 0, 0, NULL, &_inner_error0_);
#line 42 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 358 "filter.c"
				gboolean _tmp9_ = FALSE;
#line 42 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
				g_propagate_error (error, _inner_error0_);
#line 42 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
				_g_free0 (opts);
#line 42 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
				return _tmp9_;
#line 366 "filter.c"
			}
#line 42 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
			_tmp7_ = _tmp8_;
#line 370 "filter.c"
		} else {
#line 42 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
			_tmp7_ = FALSE;
#line 374 "filter.c"
		}
#line 42 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
		if (_tmp7_) {
#line 43 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
			result = FALSE;
#line 43 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
			_g_free0 (opts);
#line 43 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
			return result;
#line 384 "filter.c"
		}
	}
#line 44 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	_tmp10_ = g_regex_get_pattern (regex);
#line 44 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	g_debug ("filter.vala:44: blocked by pattern regexp=%s -- %s", _tmp10_, request_uri);
#line 45 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	result = TRUE;
#line 45 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	_g_free0 (opts);
#line 45 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	return result;
#line 397 "filter.c"
}

static void
adblock_filter_class_init (AdblockFilterClass * klass,
                           gpointer klass_data)
{
#line 14 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	adblock_filter_parent_class = g_type_class_peek_parent (klass);
#line 14 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	g_type_class_adjust_private_offset (klass, &AdblockFilter_private_offset);
#line 14 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	((AdblockFilterClass *) klass)->insert = (void (*) (AdblockFilter*, const gchar*, GRegex*)) adblock_filter_real_insert;
#line 14 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	((AdblockFilterClass *) klass)->lookup = (GRegex* (*) (AdblockFilter*, const gchar*)) adblock_filter_real_lookup;
#line 14 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	((AdblockFilterClass *) klass)->size = (guint (*) (AdblockFilter*)) adblock_filter_real_size;
#line 14 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	G_OBJECT_CLASS (klass)->finalize = adblock_filter_finalize;
#line 416 "filter.c"
}

static void
adblock_filter_instance_init (AdblockFilter * self,
                              gpointer klass)
{
#line 14 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	self->priv = adblock_filter_get_instance_private (self);
#line 425 "filter.c"
}

static void
adblock_filter_finalize (GObject * obj)
{
	AdblockFilter * self;
#line 14 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ADBLOCK_TYPE_FILTER, AdblockFilter);
#line 15 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	_g_object_unref0 (self->priv->optslist);
#line 16 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	_g_hash_table_unref0 (self->rules);
#line 14 "/usr/src/RPM/BUILD/midori-v9.0/extensions/adblock/filter.vala"
	G_OBJECT_CLASS (adblock_filter_parent_class)->finalize (obj);
#line 440 "filter.c"
}

GType
adblock_filter_get_type (void)
{
	return adblock_filter_type_id;
}

GType
adblock_filter_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (AdblockFilterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) adblock_filter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AdblockFilter), 0, (GInstanceInitFunc) adblock_filter_instance_init, NULL };
	adblock_filter_type_id = g_type_module_register_type (module, ADBLOCK_TYPE_FEATURE, "AdblockFilter", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	AdblockFilter_private_offset = sizeof (AdblockFilterPrivate);
	return adblock_filter_type_id;
}

